
;       -=-=-=-=-=-=-=-=-=-
; ----== [New File Creator] ==----
;       -=-=-=-=-=-=-=-=-=-
; This program creates a dialog where the user can enter a path and a filename.
; Then the program creates the file with the specified attributes.
; ---
; At the startup the path is the current directory.
; The command-line specifies the filename.
; Program usage:
; newfile [filename]
; ---
; This program designed for Total Commander, you can place the program in
; the toolbar & easily create a new file.
; The program is designed for ANSI string supports.
; -=-=-=-*-=-=-=-
; This source created with MASM syntax, [Zord^0e] 2004.
; ml /c /coff newfile.asm
; link /SUBSYSTEM:WINDOWS newfile.obj newfile.res

.386
.model	flat, stdcall
option	casemap:none

include		\masm32\include\windows.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\user32.inc
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib

include		newfile.inc	; resource IDs
include		string.asm	; ANSI string functions

DlgProc		proto	:DWORD,:DWORD,:DWORD,:DWORD

  .Const
DlgName		db	"MainDlg",0

  .Data
f_atrb		dd	FILE_ATTRIBUTE_NORMAL

  .Code
_entry:
		invoke	GetModuleHandle, 0
		invoke	DialogBoxParam, eax, addr DlgName, 0, addr DlgProc, 0
		invoke	ExitProcess, eax

DlgProc		proc	hWnd, uMsg, wParam, lParam

	LOCAL	dFile[256]:BYTE					; filename to create
	LOCAL	sPath[2*MAX_PATH]:BYTE				; file path

	; -=-=-=-
	; Windows message handler
	; -=-=-=-
		cmp	uMsg, WM_COMMAND
		je	$WM_COMMAND
		cmp	uMsg, WM_INITDIALOG
		je	$WM_INITDIALOG
		cmp	uMsg, WM_CLOSE
		je	$WM_CLOSE
		xor	eax, eax
		ret
$WM_INITDIALOG:
		push	esi
		lea	esi, sPath
		invoke	GetCurrentDirectory, sizeof sPath, esi	; set the current directory
		invoke	SetDlgItemText, hWnd, IDC_PATH, esi	; to path control
		pop	esi

		invoke	GetCommandLine
		cmp	byte ptr [eax], 34			; parse command-line
		jne	_@1
@@:
		add	eax, 1					; scan through quotes
		cmp	byte ptr [eax], 34
		jne	@B
_@1:
		add	eax, 1					; points to the first argument
		cmp	byte ptr [eax], 0			; but look if no first arg
		je	_@2
		cmp	byte ptr [eax], 32
		jne	_@1
		add	eax, 1
_@2:
		invoke	SetDlgItemText, hWnd, IDC_FILE, eax	; set it for filename
		jmp	_exit
$WM_COMMAND:
	; -=-=-=-
	; File archive changes
	; -=-=-=-
		cmp	word ptr [wParam], IDC_ARCHIVE
		jne	@F
		xor	f_atrb, FILE_ATTRIBUTE_ARCHIVE		; Toggle archive attribute
		jmp	_exit
@@:
		cmp	word ptr [wParam], IDC_HIDDEN
		jne	@F
		xor	f_atrb, FILE_ATTRIBUTE_HIDDEN		; Toggle hidden attribute
		jmp	_exit
@@:
		cmp	word ptr [wParam], IDC_READONLY
		jne	@F
		xor	f_atrb, FILE_ATTRIBUTE_READONLY		; Toggle read-only attribute
		jmp	_exit
@@:
		cmp	word ptr [wParam], IDC_SYSTEM
		jne	@F
		xor	f_atrb, FILE_ATTRIBUTE_SYSTEM		; Toggle system attribute
		jmp	_exit
@@:
		cmp	word ptr [wParam], IDC_CREATE
		jne	@F
		invoke	GetDlgItemText, hWnd, IDC_PATH, addr sPath, sizeof sPath	; construct path+filename
		mov	[dFile], '\'
		invoke	GetDlgItemText, hWnd, IDC_FILE, addr dFile+1, sizeof dFile-1
		invoke	s_cat, addr sPath, addr dFile					; path\filename

		invoke	CreateFile, addr sPath, GENERIC_READ, FILE_SHARE_READ, 0,\	; create the file
			CREATE_NEW, f_atrb, 0
		invoke	CloseHandle, eax
		jmp	$WM_CLOSE
@@:
		cmp	word ptr [wParam], IDC_CANCEL
		jne	_exit
$WM_CLOSE:
		invoke	EndDialog, hWnd, 0
_exit:
		mov	eax, 1
		ret
DlgProc		endp

end	_entry
