
; -=-=-=-=-=-=-=-=-
; String functions
; -=-=-=-=-=-=-=-=-

s_cat	proto	:DWORD,:DWORD
s_cpy	proto	:DWORD,:DWORD
s_len	proto	:DWORD

  .Code
COMMENT	%

  -=-=-=-
  s_len(PTR string)
  -=-=-=-

  s_len returns the length of a null-terminated string.

  string	::	pointer to a string.

  eax contains the length of the string.

	%

s_len		proc	pSrc

		mov	edx, pSrc
		xor	eax, eax
@@:
		cmp	byte ptr [edx], 0
		je	@F
		add	edx, 1
		add	eax, 1
		jmp	@B
@@:		ret
s_len		endp

COMMENT	%

  -=-=-=-
  s_cpy(PTR destBuff, PTR srcBuff)
  -=-=-=-

  s_cpy copies srcBuff to destBuff.

  destBuff	::	pointer to a destination buffer.
  srcBuff	::	pointer to an ASCII string to copy.

  No return value.

	%

s_cpy		proc	uses edi pDst, pSrc

		mov	edx, pSrc
		mov	edi, pDst
		xor	ecx, ecx
@@:
		mov	al, [edx+ecx]
		mov	[edi+ecx], al
		add	ecx, 1
		test	al, al
		jnz	@B
		ret
s_cpy		endp

COMMENT	%

  -=-=-=-
  s_cat(PTR string1, PTR string2)
  -=-=-=-

  s_cat appends string2 to string1.

  string1	::	pointer to an ASCII string.
  string2	::	pointer to an ASCCI string.

  No return value.

  -=-=-=-

	%

s_cat		proc	uses esi pSrc, pAdd

		mov	esi, pSrc
		invoke	s_len, esi
		add	esi, eax
		invoke	s_cpy, esi, pAdd
		ret
s_cat		endp
